package Demo;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class ThreadSafePrintStream extends PrintStream {
	
	private static HashMap<Thread, PrintStream> streamsMap = new HashMap<Thread, PrintStream>();
	public static Map<Thread, PrintStream> streams = Collections.synchronizedMap(streamsMap);	
	private PrintStream orig;
	
	public ThreadSafePrintStream(PrintStream orig) {
		super(orig, true);
		this.orig = orig;
	}
	
	public synchronized void addStream(PrintStream stream, Thread thread) {
		streams.put(thread, stream);
	}
	
	public synchronized void removeStream(Thread thread) {
		streams.remove(thread);
	}
	
	public synchronized void println() {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println();
		}
	}

	public synchronized void println(boolean x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}

	public synchronized void println(char x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(char[] x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(double x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(float x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(int x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(long x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(Object x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}
	
	public synchronized void println(String x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.println(x);
		}
	}

	public synchronized void print(boolean x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		} 
	}

	public synchronized void print(char x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(char[] x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(double x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(float x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(int x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(long x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(Object x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}
	
	public synchronized void print(String x) {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.print(x);
		}
	}

	public synchronized boolean checkError() {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			return stream.checkError();
		}		
		return false;
	}
	
	public synchronized void close() {
		
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.close();
		}				
	}
	
	public synchronized void flush() {
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.flush();
		}		
	}

	public synchronized void write(byte[] buf, int off, int len) {
//		orig.print("(w1-");
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
//			orig.print("Thread:"+Thread.currentThread()+"Stream:"+stream.toString()+ "(" + off + ","+ len + ")" + "-->");
	//		orig.write(buf, off, len);
			stream.write(buf, off, len);
		}				
	//	orig.println("-w1)");
	}
	
	public synchronized void write(byte[] b) {
//		orig.print("(w2");
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			try {
				stream.write(b);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}				
//		orig.print("w2)");
	}
	
	public synchronized void write(int b) {
//		orig.print("(w3");
		PrintStream stream = streams.get(Thread.currentThread());
		if (stream != null) {
			stream.write(b);
		}				
//		orig.print("w3)");
	}

}
